unit Option;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  IniFiles, Dialogs, ComCtrls, Main, StdCtrls, Functions;

type
  TfmOptions = class(TForm)
    Status: TStatusBar;
    GroupBox1: TGroupBox;
    Foldername: TEdit;
    Button1: TButton;
    RefCh: TCheckBox;
    ChCh: TCheckBox;
    GroupBox3: TGroupBox;
    groupbox: TComboBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    GroupBox4: TGroupBox;
    DIZT: TEdit;
    Button2: TButton;
    Button3: TButton;
    GroupBox5: TGroupBox;
    Edit2: TEdit;
    Add: TButton;
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit2Change(Sender: TObject);
    procedure FoldernameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmOptions: TfmOptions;
  GDI: Byte = 1; // 1 - group,2  - user, 3 - gui
  IniFileName: string;

implementation

{$R *.dfm}

procedure TfmOptions.FormShow(Sender: TObject);
var
  t1: string;
begin
  t1 := IncludeTrailingPathDelimiter(ExtractFilePath(paramstr(0))) +
    'global_diz.ini';
  if not FileExists(t1) then
    IniFileName := GetSettingsFile
  else
    IniFileName := t1;
  Status.Panels[0].Text := 'IniFileName: ' + IniFileName;
  GetGroups(groupbox, Settings);
  Foldername.Text := Settings.GlobaldizFolder;
  if Foldername.Text = '\' then
    Foldername.Text := '';
  RefCh.Checked := Settings.RefreshPanels;
  ChCh.Checked := Settings.ConfirmReplace;
end;

procedure TfmOptions.RadioButton1Click(Sender: TObject);
begin
  GDI := 1;
  GetGroups(groupbox, Settings);
end;

procedure TfmOptions.RadioButton2Click(Sender: TObject);
begin
  GDI := 2;
  GetUserColumns(groupbox, Settings);
end;

procedure TfmOptions.RadioButton3Click(Sender: TObject);
begin
  GDI := 3;
end;

procedure TfmOptions.Button3Click(Sender: TObject);
begin
  if iset.OPTIONS then
    application.Terminate
  else
    fmOptions.Close;
end;

procedure TfmOptions.AddClick(Sender: TObject);
var
  RunString: string;
begin
  RunString := '"' + application.ExeName + '" /FILE="%1" ';
  case GDI of
    1:
      RunString := RunString + '/GROUP="' + groupbox.Text + '"';
    2:
      RunString := RunString + '/USER="' + groupbox.Text + '"';
    3:
      RunString := RunString + '/G';
  end;
  RunString := RunString + ' /DIZ="' + DIZT.Text + '"';
  AddContextMenu(Edit2.Text, RunString);
end;

procedure TfmOptions.Button1Click(Sender: TObject);
begin
  Foldername.Text := GiveFolder('Select folder', fmOptions.Handle)
  // Application.handle);
end;

procedure TfmOptions.Button2Click(Sender: TObject);
var
  i: TIniFile;
begin
  i := TIniFile.Create(IniFileName);
  try
    i.WriteString('Main', 'GlobalDizFolder',
      ExcludeTrailingPathDelimiter(Foldername.Text));
    i.WriteBool('Main', 'RefreshPanels', RefCh.Checked);
    i.WriteBool('Main', 'ConfirmReplace', ChCh.Checked);
  finally
    i.Free;
  end;
  Button3.Click;
end;

procedure TfmOptions.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Button3.Click;
end;

procedure TfmOptions.Edit2Change(Sender: TObject);
begin
  if length(Edit2.Text) < 1 then
    Add.Enabled := False
  else
    Add.Enabled := True;
end;

procedure TfmOptions.FoldernameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    fmOptions.Close;
end;

end.
